/* WGStandardOptionController.m created by epeyton on Wed 18-Aug-1999 */

#import "WGStandardOptionController.h"

@implementation WGStandardOptionController

- (void)loadFromDictionary:(NSDictionary *)aDict
{
    // load the params from this dict ...

    // strings
    if ([aDict objectForKey:@"OutputDir"]) {
        [outputDirectoryTextField setStringValue:[aDict objectForKey:@"OutputDir"]];
    }
    if ([aDict objectForKey:@"URL"]) {
        [urlTextField setStringValue:[aDict objectForKey:@"URL"]];
    }
    if ([aDict objectForKey:@"AuthUserName"]) {
        [authUserID setStringValue:[aDict objectForKey:@"AuthUserName"]];
    }
    if ([aDict objectForKey:@"AuthPassword"]) {
        [authPassword setStringValue:[aDict objectForKey:@"AuthPassword"]];
    }
    if ([aDict objectForKey:@"EmailAddress"]) {
        [emailAddressTextField setStringValue:[aDict objectForKey:@"EmailAddress"]];
    }
    if ([aDict objectForKey:@"UserAgent"]) {
        [userAgentTextField setStringValue:[aDict objectForKey:@"UserAgent"]];
    }

    // check boxes
    if ([[aDict objectForKey:@"IgnoresRobots"] intValue]) {
        [ignoreRobotsCheckBox setIntValue:[[aDict objectForKey:@"IgnoresRobots"] intValue]];
    }
    if ([[aDict objectForKey:@"RewriteLinks"] intValue]) {
        [rewriteLinksCheckBox setIntValue:[[aDict objectForKey:@"RewriteLinks"] intValue]];
    }
    if ([[aDict objectForKey:@"Authenticate"] intValue]) {
        [authenticateCheckBox setIntValue:[[aDict objectForKey:@"Authenticate"] intValue]];
    }
    if ([[aDict objectForKey:@"StayOnSite"] intValue]) {
        [stayOnSiteCheckBox setIntValue:[[aDict objectForKey:@"StayOnSite"] intValue]];
    }
    if ([[aDict objectForKey:@"StayInDirectory"] intValue]) {
        [stayInDirectoryCheckBox setIntValue:[[aDict objectForKey:@"StayInDirectory"] intValue]];
    }
    if ([[aDict objectForKey:@"RemoveOldFiles"] intValue]) {
        [removeOldFilesCheckBox setIntValue:[[aDict objectForKey:@"RemoveOldFiles"] intValue]];
    }
    if ([[aDict objectForKey:@"DisplayTimes"] intValue]) {
        [displayTimesCheckBox setIntValue:[[aDict objectForKey:@"DisplayTimes"] intValue]];
    }

    
    if ([[aDict objectForKey:@"Mode"] intValue]) {
        [modePopUpButton selectItemAtIndex:[[aDict objectForKey:@"Mode"] intValue]];
    }
    if ([[aDict objectForKey:@"URLStrategy"] intValue]) {
        [urlStrategyPopUpButton selectItemAtIndex:[[aDict objectForKey:@"URLStrategy"] intValue]];
    }
    return;
}

- (NSDictionary *)saveDict
{
    NSMutableDictionary *retDict = [NSMutableDictionary dictionary];

    [retDict setObject:[outputDirectoryTextField stringValue] forKey:@"OutputDir"];
    [retDict setObject:[urlTextField stringValue] forKey:@"URL"];
    [retDict setObject:[authUserID stringValue] forKey:@"AuthUserName"];
    [retDict setObject:[authPassword stringValue] forKey:@"AuthPassword"];
    [retDict setObject:[emailAddressTextField stringValue] forKey:@"EmailAddress"];
    [retDict setObject:[userAgentTextField stringValue] forKey:@"UserAgent"];

    [retDict setObject:[NSNumber numberWithInt:[rewriteLinksCheckBox intValue]] forKey:@"RewriteLinks"];
    [retDict setObject:[NSNumber numberWithInt:[authenticateCheckBox intValue]] forKey:@"Authenticate"];
    [retDict setObject:[NSNumber numberWithInt:[ignoreRobotsCheckBox intValue]] forKey:@"IgnoresRobots"];
    [retDict setObject:[NSNumber numberWithInt:[stayOnSiteCheckBox intValue]] forKey:@"StayOnSite"];
    [retDict setObject:[NSNumber numberWithInt:[stayInDirectoryCheckBox intValue]] forKey:@"StayInDirectory"];
    [retDict setObject:[NSNumber numberWithInt:[displayTimesCheckBox intValue]] forKey:@"DisplayTimes"];
    [retDict setObject:[NSNumber numberWithInt:[removeOldFilesCheckBox intValue]] forKey:@"RemoveOldFiles"];

    [retDict setObject:[NSNumber numberWithInt:[modePopUpButton indexOfItem:[modePopUpButton selectedItem]]] forKey:@"Mode"];
    [retDict setObject:[NSNumber numberWithInt:[urlStrategyPopUpButton indexOfItem:[urlStrategyPopUpButton selectedItem]]] forKey:@"URLStrategy"];
    
    return [NSDictionary dictionaryWithDictionary:retDict];
}

- (NSArray *)optionsForRun
{
    NSMutableArray *retValue = [NSMutableArray array];

    if ([[outputDirectoryTextField stringValue] length]) {
        [retValue addObject:@"-cdir"];
    	[retValue addObject:[[outputDirectoryTextField stringValue] stringByExpandingTildeInPath]];
    }
    if ([[emailAddressTextField stringValue] length]) {
        [retValue addObject:@"-from"];
        [retValue addObject:[emailAddressTextField stringValue]];
    }
    if ([[userAgentTextField stringValue] length]) {
        [retValue addObject:@"-identity"];
        [retValue addObject:[userAgentTextField stringValue]];
    }

    if ([rewriteLinksCheckBox intValue]) { //checked
        [retValue addObject:@"-Relocate"];
    } else { //uncheck
        [retValue addObject:@"-noRelocate"];
    }

    if ([ignoreRobotsCheckBox intValue]) { //checked
        [retValue addObject:@"-noRobots"];
    } else { //uncheck
        [retValue addObject:@"-Robots"];
    }

    if ([stayOnSiteCheckBox intValue]) { //checked
        [retValue addObject:@"-dont_leave_site"];
    } else { //uncheck
        [retValue addObject:@"-leave_site"];
    }

    if ([stayInDirectoryCheckBox intValue]) { //checked
        [retValue addObject:@"-dont_leave_dir"];
    } else { //uncheck
        [retValue addObject:@"-leave_dir"];
    }

    if ([removeOldFilesCheckBox intValue]) { //checked
        [retValue addObject:@"-remove_old"];
    } else { //uncheck
        [retValue addObject:@"-noremove_old"];
    }

    if ([displayTimesCheckBox intValue]) { //checked
        [retValue addObject:@"-stime"];
    } else { //uncheck
        [retValue addObject:@"-nostime"];
    }

    if ([authenticateCheckBox intValue]) {
        [retValue addObject:@"-auth_scheme"];
        [retValue addObject:@"1"];

        if ([[authUserID stringValue] length]) {
            [retValue addObject:@"-auth_name"];
            [retValue addObject:[authUserID stringValue]];
        }
        if ([[authPassword stringValue] length]) {
            [retValue addObject:@"-auth_passwd"];
            [retValue addObject:[authPassword stringValue]];
        }
    }

    { // mode
    	[retValue addObject:@"-mode"];


        switch ([modePopUpButton indexOfItem:[modePopUpButton selectedItem]]) {
                case 0:
                    [retValue addObject:@"normal"];
                    break;
                case 1:
                    [retValue addObject:@"linkupdate"];
                    break;
                case 2:
                    [retValue addObject:@"sync"];
                    break;
                case 3:
                    [retValue addObject:@"singlepage"];
                    break;
                case 4:
                    [retValue addObject:@"resumeregets"];
                    break;
                case 5:
                    [retValue addObject:@"dontstore"];
                    break;
                case 6:
                    [retValue addObject:@"singlereget"];
                    break;
                case 7:
                    [retValue addObject:@"reminder"];
                    break;

            }

        [retValue addObject:@"-url_strategy"];

        switch ([urlStrategyPopUpButton indexOfItem:[urlStrategyPopUpButton selectedItem]]) {
                case 0:
                    [retValue addObject:@"level"];
                    break;
                case 1:
                    [retValue addObject:@"leveli"];
                    break;
                case 2:
                    [retValue addObject:@"pre"];
                    break;
                case 3:
                    [retValue addObject:@"prei"];
                    break;
            }
    }
    
    return [NSArray arrayWithArray:retValue];
}

- (NSArray *)urlsForRun
{
    NSMutableArray *retValue = [NSMutableArray array];

    if ([[urlTextField stringValue] length]) {
        [retValue addObject:[urlTextField stringValue]];
    }
    return [NSArray arrayWithArray:retValue];
}

- (void)openDownloadDirectory:(id)sender
{
[[NSWorkspace sharedWorkspace] openFile:[NSString stringWithFormat:@"%@/%@", [[outputDirectoryTextField stringValue] stringByExpandingTildeInPath], @"/http"]];
    
    return;
}

- (void)setURL:(NSString *)theUrl
{
    NSURL *anUrl = [NSURL URLWithString:theUrl];
    [urlTextField setStringValue:[NSString stringWithFormat:@"%@:%@", [anUrl scheme], [anUrl resourceSpecifier]]];
}

@end
